/*+==========================================================================
  File:      corhostdlg.h
             
----------------------------------------------------------------------------
  This file is part of the Microsoft COM+ 2.0 Samples.

  Copyright (C) 1998-1999 Microsoft Corporation.  All rights reserved.
==========================================================================+*/

#if !defined(AFX_CORHOSTDLG_H__0B1FC9B4_2FFB_11D3_A18A_00A0C9DE865A__INCLUDED_)
#define AFX_CORHOSTDLG_H__0B1FC9B4_2FFB_11D3_A18A_00A0C9DE865A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

using namespace std;
/////////////////////////////////////////////////////////////////////////////
// CCorHostDlg dialog

struct CurrentAssembly
{
	CString    m_name;
	_Assembly *m_pAssembly;
	PBYTE      m_pbFile;
};

class CCorHostDlg : public CDialog
{
// Construction
public:
	CCorHostDlg(CWnd* pParent = NULL);	// standard constructor
	~CCorHostDlg();

// Dialog Data
	//{{AFX_DATA(CCorHostDlg)
	enum { IDD = IDD_CORHOST_DIALOG };
	CButton	m_newDomain;
	CComboBox	m_classes;
	CString	m_currentAssemblyName;
	CString	m_result;
	CString	m_domainName;
	CListBox	m_methodsList;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCorHostDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CCorHostDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnExecute();
	afx_msg void OnListclasses();
	afx_msg void OnEnumdomains();
	afx_msg void OnDone();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
	ICorRuntimeHost *m_pCorHost;
	vector<_AppDomain *> m_domains;
	CurrentAssembly  m_currentAssembly;

	void        Cleanup();
	_AppDomain *AddNewDomain(const CString& name);

	_Assembly  *SetCurrentAssembly(const CString& name, bool bIsPath, _AppDomain *pDomain);
	_Assembly  *GetCurrentAssembly();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CORHOSTDLG_H__0B1FC9B4_2FFB_11D3_A18A_00A0C9DE865A__INCLUDED_)
